within ;
package MinPhyslib




  model O2MinimalBus
    Physiolibrary.Chemical.Substance veins(solute_start=0.02)
      annotation (Placement(transformation(extent={{-64,-24},{-44,-4}})));
    Physiolibrary.Chemical.Substance arteries(solute_start=0.02)
      annotation (Placement(transformation(extent={{54,-24},{74,-4}})));
    Physiolibrary.Chemical.MolarStream lungsInstream
                                                   annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=270,
          origin={-38,26})));
    Physiolibrary.Chemical.SoluteFlowPump tissuesFlow    annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=180,
          origin={8,-56})));
    Physiolibrary.Chemical.UnlimitedStorage tissues(concentration=1)
      annotation (Placement(transformation(extent={{-2,-94},{18,-74}})));
    Physiolibrary.Chemical.MolarStream tissuesStream
                                                    annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={30,-36})));
    Physiolibrary.Chemical.MolarStream lungsOutstream
                                                    annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=270,
          origin={36,26})));
    Physiolibrary.Types.Constants.VolumeFlowRateConst bloodFlow(k=
          9.1666666666667e-05)
      annotation (Placement(transformation(extent={{-96,34},{-52,54}})));
    Physiolibrary.Types.Constants.MolarFlowRateConst tissuesFlowRateConst(k=0.00045)
                   annotation (Placement(transformation(
          extent={{-22,-10},{22,10}},
          rotation=180,
          origin={66,-56})));
    Physiolibrary.Chemical.SoluteFlowPump lungsOutflow    annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=180,
          origin={6,62})));
    Physiolibrary.Chemical.UnlimitedStorage alveolSpace(concentration=1)
      annotation (Placement(transformation(extent={{-78,68},{-50,96}})));
    Physiolibrary.Types.Constants.MolarFlowRateConst LungsFlowRateConst(k=0.0007)
                  annotation (Placement(transformation(
          extent={{-20,-20},{20,20}},
          rotation=180,
          origin={50,72})));
    Physiolibrary.Chemical.UnlimitedStorage lungsIn(concentration=1)
      annotation (Placement(transformation(extent={{-24,16},{-4,36}})));
    Physiolibrary.Types.BusConnector busConnector
      annotation (Placement(transformation(extent={{-92,-90},{-52,-50}})));
  equation
    connect(arteries.q_out, tissuesStream.q_in)  annotation (Line(
        points={{64,-14},{64,-36},{40,-36}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(tissuesStream.q_out, tissuesFlow.q_in)   annotation (Line(
        points={{20,-36},{8,-36},{8,-46}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(tissuesFlow.q_out, tissues.q_out)             annotation (Line(
        points={{8,-66},{8,-84},{8.2,-84}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(veins.q_out, tissuesStream.q_out)    annotation (Line(
        points={{-54,-14},{-54,-36},{20,-36}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(veins.q_out, lungsInstream.q_in)   annotation (Line(
        points={{-54,-14},{-54,26},{-48,26}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(lungsOutstream.q_out, tissuesStream.q_in)
                                                   annotation (Line(
        points={{46,26},{64,26},{64,-36},{40,-36}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(bloodFlow.y, lungsInstream.solventFlow)         annotation (Line(
        points={{-53.76,44},{-38,44},{-38,32}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(bloodFlow.y, lungsOutstream.solventFlow)         annotation (Line(
        points={{-53.76,44},{36,44},{36,32}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(bloodFlow.y, tissuesStream.solventFlow)          annotation (Line(
        points={{-53.76,44},{12,44},{12,-42},{30,-42}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(tissuesFlowRateConst.y, tissuesFlow.soluteFlow)  annotation (Line(
        points={{41.8,-56},{14,-56}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(lungsOutflow.q_out, lungsOutstream.q_in)  annotation (Line(
        points={{6,52},{6,26},{26,26}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(alveolSpace.q_out, lungsOutflow.q_in)          annotation (Line(
        points={{-63.72,82},{6,82},{6,72}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(lungsOutflow.soluteFlow, LungsFlowRateConst.y)     annotation (Line(
        points={{12,62},{20,62},{20,72},{28,72}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(lungsInstream.q_out, lungsIn.q_out)         annotation (Line(
        points={{-28,26},{-13.8,26}},
        color={200,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(veins.solventVolume, busConnector.veinsVolume) annotation (Line(
        points={{-62,-8},{-68,-8},{-68,-70},{-72,-70}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    connect(arteries.solventVolume, busConnector.arterialVolume) annotation (
        Line(
        points={{56,-8},{-6,-8},{-6,-70},{-72,-70}},
        color={0,0,127},
        smooth=Smooth.None), Text(
        string="%second",
        index=1,
        extent={{6,3},{6,3}}));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,
              -100},{100,100}}),      graphics));
  end O2MinimalBus;

  model CVSMinimalBus
    Physiolibrary.Hydraulic.ElacticBalloon
                   arteries(
      zeroPressureVolume=0,
      volume_start=0.001,
      compliance=7.5006157584566e-08)
      annotation (Placement(transformation(extent={{44,-60},{64,-40}})));
    Physiolibrary.Hydraulic.ElacticBalloon
                   veins(
      zeroPressureVolume=0,
      volume_start=0.0035,
      compliance=1.3126077577299e-05)
      annotation (Placement(transformation(extent={{-100,-60},{-80,-40}})));
    Physiolibrary.Hydraulic.Resistor
             peripheral(cond=7.1430864073035e-09)
      annotation (Placement(transformation(extent={{-26,-60},{-6,-40}})));
    Physiolibrary.Hydraulic.Pump
         rightHeart
      annotation (Placement(transformation(extent={{-72,6},{-52,26}})));
    Physiolibrary.Hydraulic.Pump
         leftHeart
      annotation (Placement(transformation(extent={{30,8},{50,28}})));
    Physiolibrary.Hydraulic.ElacticBalloon
                   pulmonaryVeins(
      zeroPressureVolume=0,
      volume_start=0.0004,
      compliance=6.0004926067653e-07)
      annotation (Placement(transformation(extent={{10,64},{30,84}})));
    Physiolibrary.Hydraulic.ElacticBalloon
                   pulmonaryArteries(
      zeroPressureVolume=0,
      volume_start=0.0001,
      compliance=5.0029107108905e-08)
      annotation (Placement(transformation(extent={{-66,64},{-46,84}})));
    Physiolibrary.Hydraulic.Resistor
             pulmonary(cond=6.9838233326989e-08)
      annotation (Placement(transformation(extent={{-34,64},{-14,84}})));
    Physiolibrary.Types.Constants.VolumeFlowRateConst volumeFlowRateConst(k(
          displayUnit="ml/min") = 9.1666666666667e-05)
      annotation (Placement(transformation(extent={{-32,28},{-12,48}})));
    Physiolibrary.Types.BusConnector busConnector
      annotation (Placement(transformation(extent={{-52,-32},{-12,8}})));
  equation
    connect(veins.q_in,rightHeart. q_in) annotation (Line(
        points={{-90,-50},{-90,16},{-72,16}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(veins.q_in,peripheral. q_in) annotation (Line(
        points={{-90,-50},{-26,-50}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(peripheral.q_out,arteries. q_in) annotation (Line(
        points={{-6,-50},{54,-50}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(rightHeart.q_out,pulmonaryArteries. q_in) annotation (Line(
        points={{-52,16},{-48,16},{-48,54},{-76,54},{-76,74},{-56,74}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(pulmonaryArteries.q_in,pulmonary. q_in) annotation (Line(
        points={{-56,74},{-34,74}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(pulmonary.q_out,pulmonaryVeins. q_in) annotation (Line(
        points={{-14,74},{20,74}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(pulmonaryVeins.q_in,leftHeart. q_in) annotation (Line(
        points={{20,74},{34,74},{34,56},{8,56},{8,18},{30,18}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(leftHeart.q_out,arteries. q_in) annotation (Line(
        points={{50,18},{54,18},{54,-50}},
        color={0,0,0},
        thickness=1,
        smooth=Smooth.None));
    connect(volumeFlowRateConst.y, leftHeart.desiredFlow) annotation (Line(
        points={{-12.8,38},{12,38},{12,24},{40,24}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(volumeFlowRateConst.y, rightHeart.desiredFlow) annotation (Line(
        points={{-12.8,38},{-6,38},{-6,22},{-62,22}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(busConnector.veinsVolume, veins.volume) annotation (Line(
        points={{-32,-12},{-60,-12},{-60,-60},{-89.8,-60}},
        color={255,204,51},
        thickness=0.5,
        smooth=Smooth.None), Text(
        string="%first",
        index=-1,
        extent={{-6,3},{-6,3}}));
    connect(busConnector.arterialVolume, arteries.volume) annotation (Line(
        points={{-32,-12},{12,-12},{12,-60},{54.2,-60}},
        color={255,204,51},
        thickness=0.5,
        smooth=Smooth.None), Text(
        string="%first",
        index=-1,
        extent={{-6,3},{-6,3}}));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,
              -100},{100,100}}),      graphics));
  end CVSMinimalBus;

  model system
    O2MinimalBus o2MinimalBus
      annotation (Placement(transformation(extent={{-28,32},{20,68}})));
    CVSMinimalBus cVSMinimalBus
      annotation (Placement(transformation(extent={{40,28},{88,64}})));
  equation
    connect(o2MinimalBus.busConnector, cVSMinimalBus.busConnector) annotation (
        Line(
        points={{-21.28,37.4},{-20,37.4},{-20,-2},{54,-2},{54,-2},{54,43.84},{
            56,43.84},{56.32,43.84}},
        color={255,204,51},
        thickness=0.5,
        smooth=Smooth.None));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{
              -100,-100},{100,100}}), graphics));
  end system;
  annotation (uses(Physiolibrary(version="1.0"), Modelica(version="3.2")));
end MinPhyslib;
